/*
 SocialCheesecake JavaScript Library v0.5.0
 https://github.com/adiezbal/SocialCheesecake
 Developed by Alicia Diez (https://github.com/adiezbal)
 Copyright 2011, Technical University of Madrid (Universidad Politecnica de Madrid)
 Licensed under the MIT or GPL Version 2 licenses.

 Copyright (C) 2012 by Technical University of Madrid (Universidad Polit?cnica de Madrid)

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
*/
var socialCheesecake=socialCheesecake||{};
(function(){socialCheesecake.Actor=function(a){if(!a)throw"No arguments passed to the function";this.id=a.id;this.name=a.name;this.grid=a.grid;this.extraInfo=a.extraInfo?a.extraInfo:void 0;this.opacity=this.grid.maxOpacity||1;this._selected=this._focused=!1;this._hidden=!0;this._filtered=!1;this.fading="none";this.parents=[];a.parent&&this.parents.push(a.parent);var b=this,a=b.getDiv();a.addEventListener("mouseover",function(){var a;b.focus();if(!b.isOrphan())for(var d in b.parents)a=b.parents[d].parent,
a.focus(),a.colorHandler("mouseover"),b.parents[d].colorHandler("mouseover")},!1);a.addEventListener("mouseout",function(){var a;b.unfocus();if(!b.isOrphan())for(var d in b.parents)a=b.parents[d].parent,a.unfocus(),a.colorHandler("mouseout"),b.parents[d].colorHandler("mouseout")},!1);a.addEventListener("click",function(){b.isSelected()?b.unselect():(b.select(),b.unfocus())},!1)};socialCheesecake.Actor.prototype.getParentsIds=function(){var a=this.parents,b=[],c;for(c in a)b.push(a[c].id);return b};
socialCheesecake.Actor.prototype.addClass=function(a){var b=this.getDiv(),c="",d=RegExp("(^|\\s)"+a+"($|\\s)");b.getAttribute("class")?(c=b.getAttribute("class"),c.match(d)||(c=c.concat(" "+a),b.setAttribute("class",c))):b.setAttribute("class",a)};socialCheesecake.Actor.prototype.removeClass=function(a){var b=this.getDiv(),c="",d=RegExp("(^|\\s)"+a+"($|\\s)");b.getAttribute("class")&&(c=b.getAttribute("class"),c.match(d)&&(d=RegExp("(^|\\s)"+a),c=b.getAttribute("class").replace(d,""),b.setAttribute("class",
c)))};socialCheesecake.Actor.prototype.isSelected=function(){return this._selected};socialCheesecake.Actor.prototype.select=function(){this._selected=!0;this.addClass("selected")};socialCheesecake.Actor.prototype.unselect=function(){this._selected=!1;this.removeClass("selected")};socialCheesecake.Actor.prototype.focus=function(){this._focused=!0;this.addClass("focused")};socialCheesecake.Actor.prototype.unfocus=function(){this._focused=!1;this.removeClass("focused")};socialCheesecake.Actor.prototype.isFocused=
function(){this.getCheesecake();return this._focused};socialCheesecake.Actor.prototype.isOrphan=function(){var a=!1;1>this.parents.length&&(a=!0);return a};socialCheesecake.Actor.prototype.hide=function(){var a=this.getDiv(),b=" display: none;";this._hidden=!0;a.getAttribute("style")&&(b=a.getAttribute("style").match(/display\s*:\s*[a-z]*;/)?a.getAttribute("style").replace(/display\s*:\s*[a-z]*;/,"display: none;"):a.getAttribute("style").concat("display: none;"));a.setAttribute("style",b);this.fading=
"none"};socialCheesecake.Actor.prototype.show=function(){var a=this.getDiv(),b=" display: inline;";this.isFiltered()||(this._hidden=!1,a.getAttribute("style")&&(b=a.getAttribute("style").match(/display\s*:\s*[a-z]*;/)?a.getAttribute("style").replace(/display\s*:\s*[a-z]*;/,"display: inline;"):a.getAttribute("style").concat("display: inline;")),a.setAttribute("style",b))};socialCheesecake.Actor.prototype.isHidden=function(){return this._hidden};socialCheesecake.Actor.prototype.isFiltered=function(){return this._filtered};
socialCheesecake.Actor.prototype.isVisible=function(){return!(this.isHidden()||this.isFiltered())};socialCheesecake.Actor.prototype.filter=function(){this._filtered=!0;this.fadeOut(100,!0)};socialCheesecake.Actor.prototype.unfilter=function(){this._filtered=!1};socialCheesecake.Actor.prototype.setDivOpacity=function(a){var a=1<a?1:a,a=0>a?0:a,b=this.getDiv();this.opacity=a;a="opacity: "+this.opacity+";";b.getAttribute("style")&&(a=b.getAttribute("style").replace(/opacity\s*:\s*[a-zA-Z0-9.]*;/g,""),
a=a.concat("opacity: "+this.opacity+";"));b.setAttribute("style",a)};socialCheesecake.Actor.prototype.fade=function(a,b){var c=this,a=a?a:300,d=this.grid.minOpacity,e=this.grid.maxOpacity,f=1E3*(e-d)/(60*a),g=0;"out"==this.fading?(g=-1,f>this.opacity-d&&(f=this.opacity-d)):"in"==this.fading&&(g=1,f>e-this.opacity&&(f=e-this.opacity));f=this.opacity+g*f;f=Math.round(1E3*f)/1E3;c.setDivOpacity(f);"out"==this.fading&&f>d||"in"==this.fading&&f<e?requestAnimFrame(function(){c.fade(a,b)}):(this.fading=
"none",b&&f<=d&&c.hide())};socialCheesecake.Actor.prototype.fadeOut=function(a,b){var c=this.grid.maxOpacity;this.fading="out";this.setDivOpacity(c);this.fade(a,b)};socialCheesecake.Actor.prototype.fadeIn=function(a,b){var c=this.grid.minOpacity;this.isFiltered()||(this.fading="in",this.setDivOpacity(c),b&&this.show(),this.fade(a,b))};socialCheesecake.Actor.prototype.getCheesecake=function(){return this.grid.parent};socialCheesecake.Actor.prototype.getDiv=function(){return document.getElementById(this.grid.divIdPrefix+
this.id)}})();socialCheesecake=socialCheesecake||{};
(function(){socialCheesecake.Cheesecake=function(a){var b=a.sectors;this.center={x:a.center.x,y:a.center.y};this.rMax=a.rMax;this.sectors=[];this.highlightedSector=null;this.auxiliarSectors=[];this.stage=new Kinetic.Stage(a.container.id,a.container.width,a.container.height);this.stage.add(new Kinetic.Layer({name:"main"}));this.grid=new socialCheesecake.Grid({parent:this,grid_id:a.grid.id,divIdPrefix:a.grid.divIdPrefix||"actor_",maxOpacity:a.grid.maxOpacity||1,minOpacity:a.grid.minOpacity||0});this.matchActorsNumber=
a.match;null==this.matchActorsNumber&&(this.matchActorsNumber=!0);this._initialState={};this._changes={};if(a.text)for(var c in a.text)socialCheesecake.text[c]=a.text[c];if(a.colors)for(var d in a.colors)for(var e in a.colors[d])socialCheesecake.colors[d][e]=a.colors[d][e];if(a.callbacks)for(d in a.callbacks)socialCheesecake.eventCallbackHandlers[d]=a.callbacks[d];this.syncSectorFocusCallbacks=this.syncSectorFocusCallbacks||!1;16>b.length&&(c=new socialCheesecake.Sector({parent:this,center:this.center,
label:"+",rOut:a.rMax,color:socialCheesecake.colors.extraSector.background,subsectors:[{name:"New Subsector 1"}],auxiliar:!0,type:"extraSector"}),this.sectors[b.length]=c);c=Math.min(b.length,16);for(d=0;d<c;d++)this.sectors[d]=new socialCheesecake.Sector({parent:this,center:this.center,id:b[d].id,label:b[d].name,rOut:a.rMax,subsectors:b[d].subsectors,type:"normalSector"});this.calculatePortions();this._setInitialState();this.draw()};socialCheesecake.Cheesecake.prototype.draw=function(){this.addToLayer(this.sectors);
this.stage.draw()};socialCheesecake.Cheesecake.prototype.disable=function(){var a=this.stage.getChildren(),b;for(b in a)a[b].listen(!1)};socialCheesecake.Cheesecake.prototype.enable=function(){var a=this.stage.getChildren(),b;for(b in a)a[b].listen(!0)};socialCheesecake.Cheesecake.prototype.focusAndBlurCheesecake=function(a){var b=this,c,d=socialCheesecake.eventCallbackHandlers.onSectorFocusBegin,e;for(e in b.sectors)b.sectors[e]===a&&(c=e);if(null==c)throw"sector doesn't belong to this cheesecake";
b.clearLayer();b.setHighlightedSector(a);b.disable();var f=new socialCheesecake.Sector({parent:b,center:b.center,phi:a.phi+a.delta,delta:2*Math.PI-a.delta,rOut:b.rMax,color:socialCheesecake.colors.greySector.background,auxiliar:!0,type:"greySector"});b.auxiliarSectors.push(f);var g=this.getAuxiliarClone(c);b.addToLayer(f);b.addToLayer(g);var h=function(){f.changeProperty("label","GO BACK");b.enable()},i=function(){var a=b.grid;a.hideAll();a.show(b.sectors[c].actors);g.splitUp()};f.rotateTo({destination:5*
Math.PI/4,callback:function(){f.resizeDelta({delta:3*Math.PI/2,anchor:"M",callback:h})},anchor:"M"});g.rotateTo({destination:Math.PI/4,callback:function(){var a=function(){g.resizeDelta({anchor:"M",callback:i})};d?b.syncSectorFocusCallbacks?d(b,a):(d(b),a()):a()},anchor:"M"})};socialCheesecake.Cheesecake.prototype.recoverCheesecake=function(){var a=this.highlightedSector,b=this.stage.getChild("main");b.getChildren();this.removeFromLayer(this.auxiliarSectors);this.auxiliarSectors=[];b.clear();this.draw();
a&&(a.color=a.originalAttr.color,a.fan(!1),a.unfocus(),this.setHighlightedSector(null))};socialCheesecake.Cheesecake.prototype.unfocusAndUnblurCheesecake=function(){var a=this,b=this.auxiliarSectors,c=socialCheesecake.eventCallbackHandlers.onSectorUnfocusEnd,d=socialCheesecake.eventCallbackHandlers.onSectorUnfocusBegin,e,f,g=function(){for(var d in b)null!=b[d].simulate?e=a.getAuxiliarClone(b[d].simulate,{phi:b[d].phi,delta:b[d].delta,rOut:b[d].rOut}):f=b[d];dummyNewDelta=a.sectors[e.simulate].delta;
dummyNewPhi=a.sectors[e.simulate].phi;e.putTogether();e.resizeDelta({anchor:"M",delta:dummyNewDelta,callback:function(){c&&c(a);a.grid.showAll();e.rotateTo({destination:dummyNewPhi})}});f.resizeDelta({anchor:"M",delta:2*Math.PI-dummyNewDelta,callback:function(){f.rotateTo({destination:dummyNewPhi+dummyNewDelta,callback:function(){a.recoverCheesecake()}})}})};d?a.syncSectorFocusCallbacks?d(a,g):(d(a),g()):g()};socialCheesecake.Cheesecake.prototype.addNewSector=function(){var a=this.sectors,b=this.getInitialState().sectors.length;
console.log(b);b={parent:this,center:this.center,id:b,label:"New Sector",rOut:this.rMax,subsectors:[{name:"New Subsector 1"}]};a.push(a[a.length-1]);b=new socialCheesecake.Sector(b);this.sectors[a.length-2]=b;this.calculatePortions()};socialCheesecake.Cheesecake.prototype.addNewSubsector=function(a){var b=this.getFocusedSector();null!=b&&(a>b.subsectors.length?console.log("Cannot add new subsector in position "+a+".This sector only has "+b.subsectors.length+" subsectors"):b.turnExtraIntoNewSubsector(a))};
socialCheesecake.Cheesecake.prototype.updateActorMembership=function(a){var b=this._changes;b.actors=b.actors||[];var b=b.actors,c=!1,d=a.id,e=a.getParentsIds(),f=a.name,a=a.extraInfo,g=socialCheesecake.eventCallbackHandlers.onChange,h;for(h in b)b[h].id==d&&(c=!0,b[h].subsectors=e);c||b.push({id:d,subsectors:e,name:f,extraInfo:a,justAdded:!1});g&&g(this)};socialCheesecake.Cheesecake.prototype.updateSectorChanges=function(a){var b=this._changes;b.sectors=b.sectors||[];var b=b.sectors,c=!1,d;for(d in b)b[d].id==
a.id&&(c=!0,b[d].subsectors=a.getSubsectorsIds(),b[d].name=a.label);c||b.push({id:a.id,subsectors:a.getSubsectorsIds(),name:a.label})};socialCheesecake.Cheesecake.prototype.calculatePortions=function(){var a=this.sectors,b=this.matchActorsNumber,c=Math.PI/8,d=Math.PI/8,e=5*Math.PI/4-c/2,f=[],g=[],h=a.length,i=0,j=2*Math.PI;a[a.length-1].auxiliar&&(a[a.length-1].phi=e,a[a.length-1].delta=c,a[a.length-1].originalAttr.phi=a[a.length-1].phi,a[a.length-1].originalAttr.delta=a[a.length-1].delta,e+=c,h=
a.length-1,j-=c);for(var c=b?j-h*d:0,k=0;k<h;k++)f[k]=a[k].actors.length,i+=f[k],g[k]=d,b||(g[k]=j/h);for(k=0;k<h;k++)g[k]=0!=i?g[k]+f[k]/i*c:j/h,a[k].phi=e,a[k].delta=g[k],a[k].originalAttr.phi=a[k].phi,a[k].originalAttr.delta=a[k].delta,e+=a[k].delta};socialCheesecake.Cheesecake.prototype.addToLayer=function(a,b){b=b||this.stage.getChild("main");if(a instanceof Array)for(var c in a)b.add(a[c].getRegion());else b.add(a.getRegion())};socialCheesecake.Cheesecake.prototype.removeFromLayer=function(a,
b){b=b||this.stage.getChild("main");if(a instanceof Array)for(var c in a)try{b.remove(a[c].getRegion())}catch(d){}else b.remove(a.getRegion())};socialCheesecake.Cheesecake.prototype.drawLayer=function(a,b){a=a||this.stage.getChild("main");if(null!=b?b:1){var c=a.getContext();c.restore();c.save()}a.draw()};socialCheesecake.Cheesecake.prototype.clearLayer=function(a){for(var a=a||this.stage.getChild("main"),b=a.getChildren(),c=b.length-1;0<=c;c--)a.remove(b[c]);a.clear()};socialCheesecake.Cheesecake.prototype.setHighlightedSector=
function(a){var b=socialCheesecake.eventCallbackHandlers.onSectorHighlight;this.highlightedSector!=a&&(this.highlightedSector=a,b&&b(this))};socialCheesecake.Cheesecake.prototype.getAuxiliarClone=function(a,b){var c=null,d=null,d=this.auxiliarSectors,e={},b=b||{},f;for(f in d)null!=d[f].simulate&&(c=d[f]);if(null!=a){d=this.sectors[a];e={phi:b.phi||d.phi,delta:b.delta||d.delta,rOut:b.rOut||d.rOut,label:b.label||d.label,borderColor:b.borderColor||socialCheesecake.colors[d.type].border,color:b.color||
d.color,fontColor:b.fontColor||socialCheesecake.colors[d.type].font,simulate:a,auxiliar:!0,type:"dummySector"};c||(c=new socialCheesecake.Sector({center:this.center,parent:this}),this.auxiliarSectors.push(c));for(var g in e)c[g]=e[g]}return c};socialCheesecake.Cheesecake.prototype.getFocusedSector=function(){var a=this.getAuxiliarClone(),b=this.sectors,c=null;a&&(c=b[a.simulate]);return c};socialCheesecake.Cheesecake.prototype.getSectorById=function(a){var b=this.sectors,c,d;for(d in b)if(b[d].id==
a){c=b[d];break}return c};socialCheesecake.Cheesecake.prototype.getSubsectorById=function(a){var b=this.sectors,c,d,e;for(e in b){c=b[e].subsectors;for(var f in c)if(c[f].id==a){d=c[f];break}}return d};socialCheesecake.Cheesecake.prototype.getChanges=function(){return this._changes};socialCheesecake.Cheesecake.prototype.getInitialState=function(){return this._initialState};socialCheesecake.Cheesecake.prototype.filter=function(a){console.log("search");var b=this.grid,c=this.highlightedSector;socialCheesecake.SearchEngine.filter(a,
b.actors);c?b.fadeIn(c.actors,100,!0):b.fadeIn(b.actors,100,!0)};socialCheesecake.Cheesecake.prototype._setInitialState=function(){var a=this._initialState,b=this.grid.actors,c=this.sectors;a.actors=[];for(var d in b)a.actors.push({id:b[d].id,subsectors:b[d].getParentsIds(),name:b[d].name,extraInfo:b[d].extraInfo});a.sectors=[];for(var e in c)"normalSector"==c[e].type&&a.sectors.push({id:c[e].id,name:c[e].label,subsectors:c[e].getSubsectorsIds()})}})();socialCheesecake=socialCheesecake||{};
(function(){socialCheesecake.colors={normalSector:{background:"#FEEEBD",border:"#D19405",font:"#D19405",click:"#FFE481",mouseover:"#FFE481",mouseup:"#FEEEBD",mouseout:"#FEEEBD"},extraSector:{background:"#FFBABA",border:"#BD1823",font:"#BD1823",click:"#FF5964",mouseover:"#FF5964",mouseup:"#FFBABA",mouseout:"#FFBABA"},greySector:{background:"#f5f5f5",click:"#f5f5f5",mouseover:"#f5f5f5",mouseout:"#f5f5f5",mouseup:"#f5f5f5",font:"#666",border:"#666"}};socialCheesecake.colors.normalSubsector=socialCheesecake.colors.normalSector;
socialCheesecake.colors.extraSubsector=socialCheesecake.colors.extraSector;socialCheesecake.colors.greySubsector=socialCheesecake.colors.greySector})();socialCheesecake=socialCheesecake||{};
(function(){socialCheesecake.eventCallbackHandlers={normalSector:{mouseover:function(a){var b=a.getCheesecake();document.body.style.cursor="pointer";b.grid.focus(a.actors);a.focus();null!=b.highlightedSector?b.highlightedSector.fan(!1,function(){a.fan(true)}):a.fan(!0);b.setHighlightedSector(a)},mouseout:function(a){var b=a.getCheesecake();document.body.style.cursor="default";b.grid.unfocusAll();a.unfocus();b.setHighlightedSector(null);a.fan(!1)},click:function(a){var b=a.getCheesecake();b.focusAndBlurCheesecake(a);
b.grid.unfocus(a.actors)}},extraSector:{mouseover:function(a){a.getCheesecake();document.body.style.cursor="pointer";a.focus()},mouseout:function(a){a.getCheesecake();document.body.style.cursor="default";a.unfocus()},click:function(a){var b=a.getCheesecake();b.focusAndBlurCheesecake(a);b.addNewSector()}},greySector:{mouseout:function(){document.body.style.cursor="default"},click:function(a){a.changeProperty("label","");a.getCheesecake().unfocusAndUnblurCheesecake()},mouseup:function(){},mouseover:function(){document.body.style.cursor=
"pointer"}},normalSubsector:{mouseover:function(a){var b=a.getCheesecake();document.body.style.cursor="pointer";b.grid.focus(a.actors);b.setHighlightedSector(a)},mouseout:function(a){var b=a.getCheesecake();document.body.style.cursor="default";b.grid.unfocus(a.actors);b.setHighlightedSector(a.parent)},click:function(a){var b=a.getCheesecake().grid.getSelectedActors();0<b.length&&a.changeMembership(b)},mouseup:function(){}},extraSubsector:{mouseover:function(a){a.resizeWidth({width:1.5*(a.originalAttr.rOut-
a.originalAttr.rIn),anchor:"m",step:1})},mouseout:function(a){a.resizeWidth({width:a.originalAttr.rOut-a.originalAttr.rIn,anchor:0==a.rIn?"rin":"m",step:1,priority:!0})},click:function(a){a.parent.turnExtraIntoNewSubsector(a.simulate)},mouseup:function(){}},onSectorHighlight:null,onSubsectorAddedBegin:null,onSubsectorAddedEnd:null,onSectorFocusBegin:null,onSectorFocusEnd:null,onSectorUnfocusBegin:null,onSectorUnfocusEnd:null,onChange:null}})();socialCheesecake=socialCheesecake||{};
(function(){socialCheesecake.Grid=function(a){if(!a)throw"No arguments passed to the function";this.actors=[];this.orphans=[];this.parent=a.parent;this.id=a.grid_id;this.divIdPrefix=a.divIdPrefix;this.maxOpacity=a.maxOpacity;this.minOpacity=a.minOpacity};socialCheesecake.Grid.prototype.addActor=function(a,b){var c=this.actors,d=this.orphans,e=null,f=!1,g;for(g in c)if(c[g].id==a.id){var f=!0,e=c[g],h=!1,i;for(i in e.parents)e.parents[i]==b&&(h=!0);h||e.parents.push(b)}if(!f){f=!1;for(g in d)d[g].id==
a.id&&(f=!0,e=d[g],d.splice(g,1),e.removeClass("orphan"),e.parents.push(b));f||(a.parent=b,a.grid=this,e=new socialCheesecake.Actor(a));c.push(e)}return e};socialCheesecake.Grid.prototype.removeActor=function(a){var b=this.actors,c=this.orphans,d;for(d in b)b[d].id==a.id&&a.isOrphan()&&(b.splice(d,1),c.push(a),a.addClass("orphan"))};socialCheesecake.Grid.prototype.getActor=function(a){var b=this.actors,c;for(c in b)if(this.actors[c].id==a)return this.actors[c];return null};socialCheesecake.Grid.prototype.getSelectedActors=
function(){var a=this.actors,b=this.orphans,c=[],d;for(d in a)a[d].isSelected()&&c.push(a[d]);for(d in b)b[d].isSelected()&&c.push(b[d]);return c};socialCheesecake.Grid.prototype.select=function(a){var b;if(a instanceof Array)for(var c in a){if(b=a[c])b instanceof socialCheesecake.Actor||(b=this.getActor(b)),b.select()}else b=a,a instanceof socialCheesecake.Actor||(b=this.getActor(a)),b.select()};socialCheesecake.Grid.prototype.selectAll=function(){this.select(this.actors)};socialCheesecake.Grid.prototype.unselect=
function(a){var b;if(a instanceof Array)for(var c in a){if(b=a[c])b instanceof socialCheesecake.Actor||(b=this.getActor(b)),b.unselect()}else b=a,a instanceof socialCheesecake.Actor||(b=this.getActor(a)),b.unselect()};socialCheesecake.Grid.prototype.unselectAll=function(){this.unselect(this.actors)};socialCheesecake.Grid.prototype.focus=function(a){var b;if(a instanceof Array)for(var c in a){if(b=a[c])b instanceof socialCheesecake.Actor||(b=this.getActor(b)),b.focus()}else b=a,a instanceof socialCheesecake.Actor||
(b=this.getActor(a)),b.focus()};socialCheesecake.Grid.prototype.focusAll=function(){this.focus(this.actors)};socialCheesecake.Grid.prototype.hide=function(a,b){var c;if(a instanceof Array)for(var d in a){if(c=a[d])c instanceof socialCheesecake.Actor||(c=this.getActor(c)),(!c.isSelected()||b)&&c.hide()}else c=a instanceof socialCheesecake.Actor?a:this.getActor(a),c.hide()};socialCheesecake.Grid.prototype.hideAll=function(){this.hide(this.actors)};socialCheesecake.Grid.prototype.show=function(a,b){var c;
if(a instanceof Array)for(var d=0;d<a.length;d++)c=a[d],c instanceof socialCheesecake.Actor||(c=this.getActor(c)),(!c.isSelected()||b)&&c.show();else c=a instanceof socialCheesecake.Actor?a:this.getActor(a),(!c.isSelected()||b)&&c.show()};socialCheesecake.Grid.prototype.showAll=function(){this.show(this.actors)};socialCheesecake.Grid.prototype.unfocus=function(a){var b;if(a instanceof Array)for(var c in a)b=a[c],b instanceof socialCheesecake.Actor||(b=this.getActor(b)),b.unfocus();else b=a,a instanceof
socialCheesecake.Actor||(b=this.getActor(a)),b.unfocus()};socialCheesecake.Grid.prototype.unfocusAll=function(){this.unfocus(this.actors)};socialCheesecake.Grid.prototype.fadeOut=function(a,b,c,d){var e;if(a instanceof Array)for(var f in a){if(e=a[f])e instanceof socialCheesecake.Actor||(e=this.getActor(e)),(!e.isSelected()||d)&&e.fadeOut(b,c)}else e=a instanceof socialCheesecake.Actor?a:this.getActor(a),(!e.isSelected()||d)&&e.fadeOut(b,c)};socialCheesecake.Grid.prototype.fadeOutAll=function(a,b){this.fadeOut(this.actors,
a,b)};socialCheesecake.Grid.prototype.fadeIn=function(a,b,c,d){var e;if(a instanceof Array)for(var f=0;f<a.length;f++)e=a[f],e instanceof socialCheesecake.Actor||(e=this.getActor(e)),(!e.isSelected()||d)&&e.fadeIn(b,c);else e=a instanceof socialCheesecake.Actor?a:this.getActor(a),(!e.isSelected()||d)&&e.fadeIn(b,c)};socialCheesecake.Grid.prototype.fadeInAll=function(a,b){this.fadeIn(this.actors,a,b)}})();socialCheesecake=socialCheesecake||{};(function(){socialCheesecake.SearchEngine={filter:function(a,b){var c=RegExp(a.toLowerCase()),d;for(d in b){var e=b[d];e.name.toLowerCase().match(c)?e.unfilter():e.filter()}}}})();socialCheesecake=socialCheesecake||{};
(function(){socialCheesecake.Sector=function(a){var b={center:{x:0,y:0},rIn:0,rOut:300,delta:Math.PI/2,phi:0,label:"",color:socialCheesecake.colors.normalSector.background,auxiliar:!1,type:"normalSector"};a||(a=b);for(var c in b)if(!(c in a)||void 0===a[c])a[c]=b[c];for(a.phi%=2*Math.PI;0>a.phi;)a.phi+=2*Math.PI;if(0>=a.delta||a.delta>2*Math.PI)throw"Delta must be greater than 0 and less than 2*pi";void 0!=a.id&&(this.id=a.id);this.x=a.center.x;this.y=a.center.y;this.rOut=a.rOut;this.rIn=a.rIn;this.phi=
a.phi;this.delta=a.delta;this.label=a.label;this.color=a.color;a.fontColor&&(this.fontColor=a.fontColor);a.borderColor&&(this.borderColor=a.borderColor);a.mouseover&&(this.mouseover=a.mouseover);a.mouseup&&(this.mouseup=a.mouseup);a.mouseout&&(this.mouseout=a.mouseout);a.click&&(this.click=a.click);this.subsectors=[];this.extraSubsectors=[];this.actors=[];null!=a.parent&&(this.parent=a.parent);null!=a.simulate&&(this.simulate=a.simulate);this.auxiliar=a.auxiliar;this.type=a.type;if(null!=a.subsectors)for(var d in a.subsectors)this.subsectors.push(new socialCheesecake.Subsector({id:a.subsectors[d].id,
label:a.subsectors[d].name,parent:this,x:this.x,y:this.y,phi:null,delta:null,rIn:null,rOut:null,actors:a.subsectors[d].actors,color:socialCheesecake.colors.normalSector.background}));this.originalAttr={x:this.x,y:this.y,phi:this.phi,delta:this.delta,rIn:this.rIn,rOut:this.rOut,color:this.color,label:this.label,simulate:this.simulate,subsectors:this.subsectors,auxiliar:this.auxiliar,type:this.type};this._region=null};socialCheesecake.Sector.newSubsectorIdRoot="new_";socialCheesecake.Sector.prototype._draw=
function(a){var b=this.x,c=this.y,d=this.phi,e=this.delta,f=this.rIn,g=this.rOut,h=this.color||socialCheesecake.colors[k].background,i=this.label,j=this.actors,k=this.type,l=this.fontColor||socialCheesecake.colors[k].font,m=0.7*(g-f)+f,n=m;a.restore();a.save();a.beginPath();a.arc(b,c,g,-d,-(d+e),!0);a.lineTo(b+f*Math.cos(-d-e),c+f*Math.sin(-d-e));a.arc(b,c,f,-(d+e),-d,!1);a.closePath();a.fillStyle=h;a.fill();a.lineWidth=2;a.strokeStyle=this.borderColor||socialCheesecake.colors[k].border;a.stroke();
this.auxiliar&&"+"==i?socialCheesecake.text.addPlusCharacter(a,b,c,0.5*(g-f)+f,d,e,l):this.parent.auxiliar&&"+"==this.parent.label?socialCheesecake.text.writeCurvedText(i,a,b,c,m,d,e,l,"newStyle"):socialCheesecake.text.writeCurvedText(i,a,b,c,m,d,e,l);this.auxiliar||(n-=socialCheesecake.text.getTextHeight(i),socialCheesecake.text.writeCurvedText("("+j.length+")",a,b,c,n,d,e,l))};socialCheesecake.Sector.prototype.getRegion=function(){if(null==this._region){var a=this;a._region=new Kinetic.Geometry({drawFunc:function(){var b=
this.getContext();a._draw(b)},name:a.label});a._region.on("mouseover",function(){a.eventHandler("mouseover")});a._region.on("mouseout",function(){a.eventHandler("mouseout")});a._region.on("click",function(){a.eventHandler("click")});a._region.on("mouseup",function(){a.eventHandler("mouseup")})}return this._region};socialCheesecake.Sector.prototype.getLayer=function(){if(this.getRegion().getParent())return this.getRegion().getLayer()};socialCheesecake.Sector.prototype.eventHandler=function(a){this.colorHandler(a);
this.callbackHandler(a)};socialCheesecake.Sector.prototype.colorHandler=function(a){var b=this.type;null!=this[a]&&null!=this[a].color?this.changeColor(this[a].color):socialCheesecake.colors[b]&&socialCheesecake.colors[b][a]&&this.changeColor(socialCheesecake.colors[b][a])};socialCheesecake.Sector.prototype.callbackHandler=function(a){var b=this.type;if(null!=this[a]&&null!=this[a].callback)this[a].callback(this);else if(socialCheesecake.eventCallbackHandlers[b]&&socialCheesecake.eventCallbackHandlers[b][a])socialCheesecake.eventCallbackHandlers[b][a](this)};
socialCheesecake.Sector.prototype.getCheesecake=function(){return this.parent};socialCheesecake.Sector.prototype.getIndex=function(){var a=this.getCheesecake(),b=null,c;for(c in a.sectors)a.sectors[c]===this&&(b=c);return b};socialCheesecake.Sector.prototype.turnExtraIntoNewSubsector=function(a){var b=this,c=this.getCheesecake(),d=this.extraSubsectors.concat(this.subsectors),e=[],f=[],g="m",h=socialCheesecake.eventCallbackHandlers.onSubsectorAddedBegin,i=socialCheesecake.eventCallbackHandlers.onSubsectorAddedEnd;
if(4<=this.subsectors.length)console.log("Reached subsectors limit. No new subsectors will be added");else{for(var j in d){var k={label:d[j].label,x:d[j].x,y:d[j].y,rIn:d[j].rIn,rOut:d[j].rOut,phi:d[j].phi,delta:d[j].delta,type:d[j].type,auxiliar:!0,parent:d[j].parent,color:d[j].color};j<this.extraSubsectors.length?f.push(new socialCheesecake.Subsector(k)):e.push(new socialCheesecake.Subsector(k))}c.disable();c.addToLayer(e.concat(f));c.removeFromLayer(d);this.addNewSubsector(a);null!=h&&h(b.subsectors[a]);
var l=this.subsectors;this.extraSubsectors=[];var m=b.extraSubsectors,n=this.getCheesecake().getAuxiliarClone();n.calculateSubportions();n.label="";n.color=socialCheesecake.colors.normalSector.background;for(j in f)j!=a&&f[j].resizeWidth({width:0,anchor:"m",step:1.5});var d=function(){for(var b=0;b<e.length;b++)e[b].changeMediumRadius({radius:b<a?l[b].getMediumRadius():l[b+1].getMediumRadius(),step:1.5});f[a].type="normalSubsector";f[a].color=l[a].color;f[a].label="";0==a?g="rin":a==f.length-1&&(g=
"rout");f[a].resizeWidth({width:"m"==g||0==m.length?l[a].getWidth():m[a].getWidth()+l[a].getWidth(),anchor:g,step:1.5,callback:p})},p=function(){f[a].label=l[a].label;f[a].changeMediumRadius({radius:l[a].getMediumRadius(),step:1.5,callback:4<=l.length?o:function(){}});if(4>l.length){b.createExtraSubsectors();n.calculateSubportions();m=b.extraSubsectors;var d={label:"+",x:m[a].x,y:m[a].y,phi:f[a].phi,delta:f[a].delta,type:"extraSubsector",auxiliar:!0,parent:f[a].parent,color:m[a].color};f.push(new socialCheesecake.Subsector(d));
f.push(new socialCheesecake.Subsector(d));for(var e=!1,d=0;d<f.length;d++)d!=a&&(f[d].rIn=d<a?m[d].getMediumRadius():m[d-1].getMediumRadius(),f[d].rOut=f[d].rIn,c.addToLayer(f[d]),f[d].resizeWidth({width:d<a?m[d].getWidth():m[d-1].getWidth(),anchor:"m",step:1.5,callback:function(){if(!e)return e=!0,o}()}))}},o=function(){c.removeFromLayer(e.concat(f));c.addToLayer(l);m&&c.addToLayer(m);c.drawLayer();c.enable();null!=i&&i(b.subsectors[a])};for(j=0;j<e.length;j++)e[j].resizeWidth({width:j<a?l[j].getWidth():
l[j+1].getWidth(),anchor:"m",step:1.5,callback:0==j?d:function(){}})}};socialCheesecake.Sector.prototype.splitUp=function(){var a=this.getCheesecake(),b=socialCheesecake.eventCallbackHandlers.onSectorFocusEnd,c=null!=this.simulate?a.sectors[this.simulate]:this,d=c.subsectors;4>d.length&&c.createExtraSubsectors();this.calculateSubportions();a.addToLayer(d.concat(c.extraSubsectors));a.drawLayer();b&&b(a)};socialCheesecake.Sector.prototype.putTogether=function(){var a=this.getCheesecake(),b=null!=this.simulate?
a.sectors[this.simulate]:this;a.removeFromLayer(b.subsectors.concat(b.extraSubsectors));b.extraSubsectors=[]};socialCheesecake.Sector.prototype.createExtraSubsectors=function(){var a=this.getCheesecake(),b=this.subsectors,c=this.extraSubsectors||[],a={x:a.center.x,y:a.center.y,label:"+",parent:this,auxiliar:!0,color:socialCheesecake.colors.extraSector.background,type:"extraSubsector"};c.splice(0,c.length);for(var d=0;d<b.length+1;d++){a.simulate=d;var e=new socialCheesecake.Subsector(a);c.push(e)}};
socialCheesecake.Sector.prototype.calculateSubportions=function(){var a=this.getCheesecake(),b=null!=this.simulate?a.sectors[this.simulate]:this,a=b.subsectors,b=b.extraSubsectors,c=this.phi,d=this.delta,e=this.rOut,f=this.rIn,g=b.length==a.length+1?0.06*(e-f):0,e=(e-f-b.length*g)/a.length,h;for(h in a)f+=g,a[h].rIn=f,a[h].originalAttr.rIn=a[h].rIn,a[h].rOut=f+e,a[h].originalAttr.rOut=a[h].rOut,a[h].phi=c,a[h].originalAttr.phi=a[h].phi,a[h].delta=d,a[h].originalAttr.delta=a[h].delta,f+=e;f=this.rIn;
for(h in b)b[h].rIn=f,b[h].originalAttr.rIn=b[h].rIn,b[h].rOut=f+g,b[h].originalAttr.rOut=b[h].rOut,b[h].delta=d,b[h].originalAttr.delta=b[h].delta,b[h].phi=c,b[h].originalAttr.phi=b[h].phi,f+=g+e};socialCheesecake.Sector.prototype.changeColor=function(a){this.changeProperty("color",a)};socialCheesecake.Sector.prototype.changeLabel=function(a){this.changeProperty("label",a)};socialCheesecake.Sector.prototype.changeProperty=function(a,b){var c=this.getCheesecake(),d=this.getLayer();this[a]=b;"normalSector"==
this.type&&"label"==a&&c.updateSectorChanges(this);d&&c.drawLayer(d)};socialCheesecake.Sector.prototype.resizeDelta=function(a){if(!a)throw"No arguments passed to the function";var b=this,c=b.delta,d=b.phi,e=0.05,f=Math.PI/2,g=1,h=!0,i=0;a.step&&(e=a.step);a.delta&&(f=a.delta);if(a.anchor){if("b"==a.anchor.toLowerCase()||"beginning"==a.anchor)g=0;if("m"==a.anchor.toLowerCase()||"middle"==a.anchor)g=0.5;if("e"==a.anchor.toLowerCase()||"end"==a.anchor)g=1}c>f?(c-f<e&&(e=c-f),c-=e,d+=g*e,i=-1):c<f&&
(f-c<e&&(e=f-c),c+=e,d-=g*e,i=1);a.priority&&(b.growDelta=i);null!=b.growDelta&&i!=b.growDelta?h=!1:(h=!0,b.growDelta=i);b.delta=c;b.phi=d;b.getCheesecake().drawLayer(b.getLayer());h&&Math.round(1E3*c)!=Math.round(1E3*f)?requestAnimFrame(function(){b.resizeDelta(a)}):(b.growDelta=null,a.callback&&a.callback())};socialCheesecake.Sector.prototype.resizeWidth=function(a){var b=this,c=this.rIn,d=this.rOut,e=d-c,f=0.05,g=e,h=1,i=0,j=!0;a.step&&(f=a.step);null!=a.width&&(g=a.width);if(0>g)throw"Width must be greater than or equal to zero";
if(a.anchor){if("i"==a.anchor.toLowerCase()||"in"==a.anchor||"rin"==a.anchor.toLowerCase())h=1;if("m"==a.anchor.toLowerCase()||"middle"==a.anchor)h=0.5;if("o"==a.anchor.toLowerCase()||"out"==a.anchor||"rout"==a.anchor.toLowerCase())h=0}e>g?(e-g<f&&(f=e-g),i=-1):e<g&&(g-e<f&&(f=g-e),i=1);a.priority&&(b.grow=i);null!=b.grow&&i!=b.grow?j=!1:(j=!0,b.grow=i);d+=i*h*f;c-=i*(1-h)*f;e=d-c;0>c&&(d+=this.rIn-c,c=0);0>=e&&b.getCheesecake().removeFromLayer(b);b.rOut=d;b.rIn=c;b.getCheesecake().drawLayer(b.getLayer());
j&&Math.round(1E3*e)!=Math.round(1E3*g)?requestAnimFrame(function(){b.resizeWidth(a)}):(b.grow=null,a.callback&&a.callback())};socialCheesecake.Sector.prototype.changeMediumRadius=function(a){var b=this,c=this.rIn,d=this.rOut,e=this.getMediumRadius();0>a.radius-this.getWidth()/2&&(a.radius=this.getWidth()/2);var f=a.radius||e,g=a.step||0.05;f>e?(f-e<g&&(g=f-e),c+=g,d+=g):(e-f<g&&(g=e-f),c-=g,d-=g);this.rIn=Math.round(1E3*c)/1E3;this.rOut=Math.round(1E3*d)/1E3;e=this.getMediumRadius();b.getCheesecake().drawLayer(b.getLayer());
Math.round(1E3*e)!=Math.round(1E3*f)?requestAnimFrame(function(){b.changeMediumRadius(a)}):a.callback&&a.callback()};socialCheesecake.Sector.prototype.focus=function(){this.changeProperty("rOut",1.05*this.originalAttr.rOut)};socialCheesecake.Sector.prototype.unfocus=function(){this.changeProperty("rOut",this.originalAttr.rOut)};socialCheesecake.Sector.prototype.fan=function(a,b){var c=Math.PI/5;a&&this.delta>=c||(a?(this.getRegion().moveToTop(),this.resizeDelta({anchor:"m",delta:c,callback:b})):this.resizeDelta({anchor:"m",
delta:this.originalAttr.delta,priority:!0,callback:b}))};socialCheesecake.Sector.prototype.rotateTo=function(a){var b=this,c=this.phi%(2*Math.PI),d=this.delta,e=0.05,f=0;if(!a)throw"No arguments passed to the function";a.step&&(e=a.step);if(null==a.destination)throw"destination must be defined";if(a.anchor){if("b"==a.anchor.toLowerCase()||"beginning"==a.anchor)f=0;if("m"==a.anchor.toLowerCase()||"middle"==a.anchor)f=0.5;if("e"==a.anchor.toLowerCase()||"end"==a.anchor)f=1}for(d=(a.destination-f*d)%
(2*Math.PI);0>d;)d+=2*Math.PI;for(;0>c;)c+=2*Math.PI;f=0;d>c?f=1:d<c&&(f=-1);Math.round(1E3*(2*Math.PI-Math.abs(d-c)))/1E3>=Math.round(1E3*Math.abs(d-c))/1E3?(Math.abs(d-c)<e&&(e=Math.abs(d-c)),c+=f*e):(2*Math.PI-Math.abs(d-c)<e&&(e=2*Math.PI-Math.abs(d-c)),d-=2*f*Math.PI,c-=f*e);b.phi=c;b.getCheesecake().drawLayer(b.getLayer());0.001<Math.abs(c-d)?(b.phi=c%(2*Math.PI),requestAnimFrame(function(){b.rotateTo({destination:a.destination,step:e,callback:a.callback,anchor:a.anchor})})):a.callback&&a.callback()};
socialCheesecake.Sector.prototype.addNewSubsector=function(a){for(var b=this.subsectors,c={parent:this,x:this.x,y:this.y,delta:this.delta,phi:this.phi,id:socialCheesecake.Sector.newSubsectorIdRoot+"S"+this.getIndex()+"s"+a},d=b.length;0<=d;d--)d>a&&(b[d]=b[d-1]),d==a&&(c.label="New Subsector "+d,b[d]=new socialCheesecake.Subsector(c));this.getCheesecake().updateSectorChanges(this);return b[a]};socialCheesecake.Sector.prototype.addActor=function(a,b){var c=this.actors,d,e=!1,f;for(f in c)if(c[f].id==
a.id){e=!0;d=c[f];var g=!1,h;for(h in d.parents)d.parents[h]==b&&(g=!0);g||d.parents.push(b)}e||(d=this==b?this.parent.addActor(a,b):this.parent.grid.addActor(a,b),c.push(d));return d};socialCheesecake.Sector.prototype.removeActor=function(a){var b=this.actors,c,d=!1,e=this.getCheesecake().grid,f;for(f in b)if(b[f].id==a.id){c=a.parents;for(var g in c)for(var h in this.subsectors)if(c[g]===this.subsectors[h]){d=!0;break}d||(b.splice(f,1),e.removeActor(a))}};socialCheesecake.Sector.prototype.getWidth=
function(){return this.rOut-this.rIn};socialCheesecake.Sector.prototype.getMediumRadius=function(){return(this.rOut+this.rIn)/2};socialCheesecake.Sector.prototype.getSubsectorsIds=function(){var a=[],b;for(b in this.subsectors)a.push(this.subsectors[b].id);return a};socialCheesecake.Sector.prototype.listen=function(a){var b=this.getRegion(),c=this;void 0===a&&(a=!0);a?(b.on("mouseover",function(){c.eventHandler("mouseover")}),b.on("mouseout",function(){c.eventHandler("mouseout")}),b.on("click",function(){c.eventHandler("click")}),
b.on("mouseup",function(){c.eventHandler("mouseup")})):(b.off("mouseover"),b.off("mouseout"),b.off("click"),b.off("mouseup"))}})();socialCheesecake=socialCheesecake||{};
(function(){socialCheesecake.Subsector=function(a){this.id=null;void 0!=a.id&&(this.id=a.id);null!=a.parent&&(this.parent=a.parent);this.label="";null!=a.label&&(this.label=a.label);this.x=a.x;this.y=a.y;this.rOut=a.rOut;this.rIn=a.rIn;this.phi=a.phi;this.delta=a.delta;this.actors=[];this.auxiliar=a.auxiliar?a.auxiliar:!1;this.type=a.type?a.type:"normalSubsector";null!=a.simulate&&(this.simulate=a.simulate);this.color=a.color||socialCheesecake.colors.normalSubsector.background;a.fontColor&&(this.fontColor=
a.fontColor);a.borderColor&&(this.borderColor=a.borderColor);null!=a.click&&(this.click=a.click);null!=a.mouseup&&(this.mouseup=a.mouseup);null!=a.mouseover&&(this.mouseover=a.mouseover);null!=a.mouseout&&(this.mouseout=a.mouseout);this.getCheesecake();if(a.actors)for(var b in a.actors)this.addActor({id:a.actors[b][0],name:a.actors[b][1],extraInfo:a.actors[b][2]},this);this.originalAttr={x:this.x,y:this.y,phi:this.phi,delta:this.delta,rIn:this.rIn,rOut:this.rOut,color:this.color,fontColor:this.fontColor,
borderColor:this.borderColor,label:this.label,auxiliar:this.auxiliar,type:this.type,simulate:this.simulate}};socialCheesecake.Subsector.prototype=new socialCheesecake.Sector({id:this.id,parent:this.parent,center:{x:this.x,y:this.y},label:this.label,rIn:this.rIn,rOut:this.rOut,phi:this.phi,delta:this.delta,auxiliar:this.auxiliar,color:this.color,fontColor:this.fontColor,borderColor:this.borderColor,type:this.type,simulate:this.simulate,mouseover:this.mouseover,mouseout:this.mouseout,mouseup:this.mouseup,
click:this.click});socialCheesecake.Subsector.prototype.getCheesecake=function(){return this.parent.parent};socialCheesecake.Subsector.prototype.getIndex=function(){var a=this.parent,b=null,c;for(c in a.subsectors)a.subsectors[c]===this&&(b=c);return b};socialCheesecake.Subsector.prototype.removeActor=function(a){var b=this.actors,c,d;for(d in b)if(b[d].id==a.id){c=a.parents;for(var e in c)c[e]===this&&c.splice(e,1);b.splice(d,1);this.parent.removeActor(a)}};socialCheesecake.Subsector.prototype.changeMembership=
function(a){var b=this.actors,c;c=!1;for(var d in a){for(var e in b)if(b[e].id==a[d].id){c=!0;this.removeActor(a[d]);break}c||(c={id:a[d].id},this.addActor(c,this));this.getCheesecake().updateActorMembership(a[d]);c=!1}this.getCheesecake().calculatePortions()}})();socialCheesecake=socialCheesecake||{};
(function(){socialCheesecake.text={style:"bold 14px sans-serif",newStyle:"bold 14px sans-serif",addPlusCharacter:function(a,b,c,d,e,f,g,h){a.font=h&&socialCheesecake.text[h]?socialCheesecake.text[h]:socialCheesecake.text.style;a.fillStyle=g||"#000";a.textAlign="center";a.textBaseline="middle";text="+";a.translate(b,c);a.rotate(-f/2-e-Math.PI/2);a.fillText(text[0],0,d);a.restore();a.save()},writeCurvedText:function(a,b,c,d,e,f,g,h,i){b.font=i&&socialCheesecake.text[i]?socialCheesecake.text[i]:socialCheesecake.text.style;
b.fillStyle=h||"#000";b.textBaseline="middle";for(var h=Math.tan(b.measureText(a).width/(a.length*e)),i=null,j=a;h*(a.length+4)>g;){if(i==a){console.log("WARNING: Infinite loop detected and stopped. Text '"+j+"' failed to be correctly truncated. Proccesed serveral times as '"+a+"' and will be returned as '"+words[0].substring(0,g/h-7)+"'. Space too small to even be able to truncate.");a=words[0].substring(0,g/h-7);break}else i=a;words=a.split(" ");1<words.length?(words.splice(words.length-1,1),a=
words.join(" ")+"..."):a=words[0].substring(0,g/h-7)+"...";h=Math.tan(b.measureText(a).width/(a.length*e))}b.translate(c,d);c=0;f+g/2>=Math.PI&&f+g/2<2*Math.PI?(c=-1,b.rotate(-(g-h*a.length)/2-f-Math.PI/2)):(c=1,b.rotate((g-h*a.length)/2+Math.PI/2-g-f));for(f=0;f<a.length;f++)b.fillText(a[f],0,-(c*e)),g=Math.tan(b.measureText(a[f]).width/e),b.rotate(c*g);b.restore();b.save()},writeCenterText:function(a,b,c,d){b.fillText(a,c-b.measureText(a).width/2,d)},getTextHeight:function(a,b){var b=b||socialCheesecake.text.style,
c=document.createElement("div"),d=0;c.setAttribute("id","getTextHeight");c.setAttribute("display","none");c.setAttribute("style","font: "+b);c.innerHTML=a;document.body.appendChild(c);d=parseInt(window.getComputedStyle(c).fontSize);document.body.removeChild(c);return d}}})();
